#include "Nextion.h"

// https://www.reddit.com/r/arduino/comments/4b6jfi/nexconfigh_for_nextion_display_on_arduino_uno/
#define ESP32
HardwareSerial HMISerial(2); // pin 16=RX, pin 17=TX

#define LEVEL_HIGH      (15)
#define LEVEL_LOW       (0)

#define CH0_OFFSET  (20 - LEVEL_HIGH/2)
#define CH1_OFFSET  (CH0_OFFSET + 20 * 1)
#define CH2_OFFSET  (CH0_OFFSET + 20 * 2)
#define CH3_OFFSET  (CH0_OFFSET + 20 * 3)


NexWaveform s0 = NexWaveform(0, 1, "s0");

static uint8_t ch0_data = LEVEL_LOW;
static uint8_t ch1_data = LEVEL_LOW;
static uint8_t ch2_data = LEVEL_LOW;
static uint8_t ch3_data = LEVEL_LOW;

void setup(void)
{
    nexInit();
    dbSerialPrintln("setup done");
}

void loop(void)
{
    static uint32_t started = 0;
    if (millis() - started >= 2000)
    {
        started = millis();    
        if (LEVEL_HIGH == ch0_data)
        {
            ch0_data = LEVEL_LOW;
        }
        else
        {
            ch0_data = LEVEL_HIGH;
        }
    }
    
    ch1_data = ch0_data + random(0, 2);
    ch2_data = ch0_data + random(0, 5);
    ch3_data = ch0_data + random(0, 8);
    
    s0.addValue(0, CH0_OFFSET + ch0_data);
    s0.addValue(1, CH1_OFFSET + ch1_data);
    s0.addValue(2, CH2_OFFSET + ch2_data);
    s0.addValue(3, CH3_OFFSET + ch3_data);
    
}


